<?php

namespace App\Helpers;

use App\Models\Syllabus;
use Illuminate\Support\Facades\DB;

class SyllabusesMigration
{
    public function migrate()
    {
        $old = DB::connection('old_thu')->table('syllabuses')->get();
//        dd($old);

        foreach ($old as $item){
//            dd($item);

            switch ($item->category_id){
                case 1:
                case 4:
                    $category = 'required';
                    $faculty_id = 2;
                    break;
                case 2:
                case 3:
                    $category = 'module_elements';
                    $faculty_id = 2;
                    break;
                case 5:
                    $category = 'summary';
                    $faculty_id = 1;
                    break;
                case 6:
                    $category = 'plan';
                    $faculty_id = 3;
                    break;
                case 36:
                    $category = 'bacalaur_medic';
                    $faculty_id = 4;
                    break;
                case 37:
                    $category = 'onestep_medic';
                    $faculty_id = 4;
                    break;
                case 38:
                    $category = 'european_discovery';
                    $faculty_id = 3;
                    break;
                case 39:
                    $category = 'slavs_filology';
                    $faculty_id = 3;
                    break;
                case 40:
                    $category = 'gumanitary_psihology';
                    $faculty_id = 3;
                    break;
                case 41:
                    $category = 'credit_programm';
                    $faculty_id = 3;
                    break;
                case 46:
                    $category = 'plan';
                    $faculty_id = 4;
                    break;
                default:
                    $category = 'None';
                    $faculty_id = 0;
            }

            $syllabus = new Syllabus();
            $syllabus->setTranslation('name', 'ka', $item->name);
            $syllabus->setTranslation('name', 'ru', $item->name);
            $syllabus->category = $category;
            $syllabus->faculty_id = $faculty_id;
            $syllabus->file = $item->file_url;
            $syllabus->save();
        }
    }
}
