<?php

namespace App\Http\Controllers;

use App\Mail\SupportRequest;
use App\Message;
use App\Models\BackpackUser;
use App\Models\Lecturer;
use App\Models\Student;
use Illuminate\Database\Eloquent\Builder;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Mail;
use function foo\func;

class Chat extends Controller
{
    protected $data = [];

    public function list( Request $request)
    {
        $current_user = Auth::user();
        $this->data['current_user'] = $current_user;
        $this->data['recipients'] = Lecturer::all();
//        $this->data['active_recipients'] = BackpackUser::with('messagesOutcoming', 'messagesIncoming')
//            ->where('messages.sender_id', Auth::user()->id)
//            ->orWhere('messages.recipient_id', Auth::user()->id)
//            ->get();
        $this->data['active_recipients'] = BackpackUser::whereHas('messagesOutcoming', function($query){
                $query->where('sender_id', Auth::user()->id);
            })
            ->orWhereHas('messagesIncoming', function ($query){
                $query->where('recipient_id', Auth::user()->id);
            })
            ->get();

        if( $interlocutor = $request->get('interlocutor') ){
            $this->data['messages'] = $this->getMessages($interlocutor);
            $this->data['recipient_id'] = $interlocutor;
        }
        return view('admin.chat', $this->data);
    }

    public function getMessages($recipient)
    {
        $messages = Message::where(function ($query) use ($recipient) {
                    $query->where('sender_id', Auth::user()->id)
                        ->where('recipient_id', $recipient);
                })
                ->orWhere(function($query) use ($recipient) {
                $query->where('sender_id', $recipient)
                    ->where('recipient_id', Auth::user()->id);
                })
                ->get();
        Message::where(function($query) use ($recipient) {
            $query->where('sender_id', $recipient)
                ->where('recipient_id', Auth::user()->id);
        })->update(['status' => 1]);
        return $messages;
    }

    public function getMessagesAjax(Request $request)
    {
        if( !empty($recipient = $request->get('recipient_id')) ){
            $messages = $this->getMessages($recipient);
            $returnHTML = view('admin.chat_messages', ['messages'=> $messages, 'recipient_id' => $recipient])->render();
            return response()->json( array('success' => true, 'html'=>$returnHTML) );
        }
        return response()->json(['error' => 'Error msg'], 404);
    }
    public function sendMessageAjax(Request $request)
    {
        if( !empty($incoming_message = $request->get('message')) && !empty($recipient = $request->get('recipient_id')) ){
            $message = new Message;
            $message->recipient_id = $recipient;
            $message->sender_id = Auth::user()->id;
            $message->message = $incoming_message;
            $message->save();

            $returnHTML = view('admin.message', ['message'=> $message])->render();
            return response()->json( array('success' => true, 'html'=>$returnHTML, 'recipient' => $recipient) );
        }
        return response()->json(['error' => 'Error msg'], 404);
    }

    public function mail()
    {
        $sender = Auth::user();
        if( $sender->hasPermissionTo('BlockSupport') ){
            return redirect('dashboard');
        }

        $this->data['recipients'] = json_decode(config('settings.support'), true);
        return view('admin.mail', $this->data);
    }

    public function sendMail(Request $request)
    {
        ini_set('display_errors', '1');
ini_set('display_startup_errors', '1');
error_reporting(E_ALL);
        $sender = Auth::user();
        if( $sender->hasPermissionTo('BlockSupport') ){
            return redirect('dashboard');
        }
        $this->data['email_from'] = $sender->email;
        $this->data['id'] = $sender->id;
        $this->data['first_name'] = $sender->first_name;
        $this->data['last_name'] = $sender->last_name;
        $this->data['email_message'] = $request->get('message');

        $available = collect( json_decode(config('settings.support'), true) );

        $filtered = $available->whereIn('slug', $request->get('recipient'));
        $recipient = [
            [
                'email' => $filtered->first()['slug'],
                'name' => $sender->first_name . ' ' . $sender->last_name,
            ]
        ];
        if( $filtered->isNotEmpty() ){
         //   Mail::to($recipient)->locale('ru')->send(new SupportRequest($this->data));
        }

        return back();
    }
}
