<?php

namespace App\Http\Controllers;

use App\Models\Questionnaire;
use App\Models\Student;
use Carbon\Carbon;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

class DashboardController extends Controller
{
    protected $data = [];

    /**
     * Create a new controller instance.
     */
    public function __construct()
    {
        $this->middleware(backpack_middleware());
    }

    /**
     * Show the admin dashboard.
     *
     * @return \Illuminate\Http\Response
     */
    public function dashboard()
    {
        $user = Auth::user();
        $this->data['title'] = trans('backpack::base.dashboard');
        if ( $user->hasRole('Student') ){

            if( !empty($student_current =  Student::find($user->id)->first()) ){
                $this->data['semester'] = $student_current->user_attributes->where('key', 'semester')->first()->value;
                $this->data['questionnaires'] = Questionnaire::where('status', true)
                                                    ->whereDate('expires_on', '>=', Carbon::now())
                                                    ->whereRaw('JSON_CONTAINS(semester, \'"'.$this->data['semester'].'"\')')->get();
            }
        }

        return view('backpack::dashboard', $this->data);
    }
}
