<?php

namespace App\Http\Controllers;

use App\Models\Group;
use App\Models\Student;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;

class MoodleController extends Controller
{
    public static function createUser($laravel_user_id, $password, $first_name, $last_name, $email, $description = null)
    {
        $moodle_user_id = self::moodleDB()->table('user')->insertGetId([
            'confirmed' => 1,
            'username' => $email,
            'password' => $password,
            'firstname' => $first_name,
            'lastname' => $last_name,
            'mnethostid' => 1,
            'email' => $email,
            'description' => $description,
        ]);

        self::laravelDB()->table('laravel_moodle_users')->insert([
            'laravel_id' => $laravel_user_id,
            'moodle_id' => $moodle_user_id
        ]);
    }

    public static function updateUser($id, $first_name, $last_name, $email, $password)
    {
//
        $moodle_uid = self::laravelDB()
            ->table('laravel_moodle_users')
            ->where('laravel_id', $id)
            ->first();
        if(isset($moodle_uid->moodle_id)){
            self::moodleDB()->table('user')
                ->where('id', $moodle_uid->moodle_id)
                ->update(
                    [
                        'username' => $email,
                        'firstname' => $first_name,
                        'lastname' => $last_name,
                        'email' => $email,
                        'password' => $password,
                    ]
                );
        } else {
            self::createUser($id, $password, $first_name, $last_name, $email);
        }
    }


    public static function deleteUser($id)
    {
        $moodle_uid = self::laravelDB()
            ->table('laravel_moodle_users')
            ->where('laravel_id', $id)
            ->first();

        self::laravelDB()->table('laravel_moodle_users')->where('laravel_id', $id)->delete();
        self::moodleDB()->table('user')->where('id', $moodle_uid->moodle_id)->delete();
    }

    // statement creation with custom list of students
    public static function createCohort($laravel_group_id, $cohort_name)
    {
        $moodle_cohort_id = self::moodleDB()->table('cohort')->insertGetId([
            'contextid' => 1,
            'name' => $cohort_name,
            'descriptionformat' => 1,
            'description' => 'from laravel',
            'visible' => 1,
            'timecreated' => time(),
            'timemodified' => time(),
        ]);

        self::laravelDB()->table('laravel_moodle_groups')->insert([
            'laravel_id' => $laravel_group_id,
            'moodle_id' => $moodle_cohort_id
        ]);
    }

    public function migrateAllUsers()
    {
        $students = Student::with('groups')->get();
        $groups = Group::All();
        foreach ($students as $student){
            self::createUser(
                $student->id,
                $student->password,
                $student->first_name,
                $student->last_name,
                $student->email,
                'Laravel id: '.$student->id
            );
        }
        foreach ($groups as $group){
            self::createCohort(
                $group->id,
                $group->name
            );
        }

        $group_users = self::laravelDB()
            ->table('group_user')
            ->leftjoin('laravel_moodle_users', 'group_user.user_id', '=', 'laravel_moodle_users.laravel_id')
            ->leftjoin('laravel_moodle_groups', 'group_user.group_id', '=', 'laravel_moodle_groups.laravel_id')
            ->select('laravel_moodle_users.laravel_id AS moodle_user_id', 'laravel_moodle_groups.laravel_id AS moodle_group_id')
            ->get();

        foreach ($group_users as $item){
            if ($item->moodle_group_id != null && $item->moodle_user_id != null){
                self::moodleDB()->table('cohort_members')->insert([
                    'cohortid' => $item->moodle_group_id,
                    'userid' => $item->moodle_id
                ]);
            }
        }
        //==============================================================================================================
    }

    private static function moodleDB ()
    {
        return DB::connection('moodle');
    }

    private static function laravelDB ()
    {
        return DB::connection('mysql');
    }
}
