<?php

namespace App\Http\Controllers;

use App\Models\Spreadsheet;
use Illuminate\Http\Request;
use PhpParser\Node\Expr\New_;

class SpreadsheetController extends Controller
{
    public function show($id)
    {
        if($id != 'null'){
            return response()->json([
                'data' => json_decode(Spreadsheet::where('id', $id)->first()->content)
            ], 200);
        }
    }

    public function showView($id = false)
    {
        if( !$id){
            $spreadsheets = Spreadsheet::all();
            return view('vendor.backpack.base.spreadsheets', ['spreadsheets' => $spreadsheets]);
        } else {
            $spreadsheet = Spreadsheet::where('id', $id)->first();
            try {
                list($thead, $tbody) = array_chunk(json_decode($spreadsheet->content), 1);
            } catch (\Exception $e) {
                return view('vendor.backpack.base.spreadsheet_single',
                    [
                        'no_data' => true
                    ]
                );
            }

            return view('vendor.backpack.base.spreadsheet_single',
                [
                    'name' => $spreadsheet->name,
                    'thead' => $thead[0],
                    'tbody' => $tbody
                ]
            );
        }
    }
}
