<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App;
use Auth;

class ThuController extends Controller
{
    public function getStudents()
    {
        App::setLocale(session()->get('language', 'ru'));
        $return = [];

        $students = \App\Models\Student::where(function ($query) {
            $query->where('first_name', 'LIKE', "%" . request()->get('q') . "%");
            $query->orWhere('last_name', 'LIKE', "%" . request()->get('q') . "%");

        });
					
		 if ($ids = Auth::user()->coordinatorAddClause()) {
				 $students = $students->whereHas('specialisations', function ($query) use ($ids) {
					$query->whereHas('faculty', function ($query) use ($ids) {
						$query->where('id', $ids);
					});
				});
		 } 

        if (!empty(request()->get('filter'))) {
            $students = $students->whereHas('groups', function ($query) {
                $query->whereIn('id', request()->get('filter'));
            });
        }

        $students = $students->get();

        foreach ($students as $student) {
            $item = [];
            $item['id'] = $student->id;
            $item['full_name'] = $student->full_name;
            $return[] = $item;
        }
        return $return;
    }

    public function getGroupsByIds()
    {
        if (empty(request()->get('filter'))) {
            $student = App\Models\Group::with('students')->get();
        } else {
            $student = App\Models\Group::with('students')
                ->whereIn('id', request()->get('filter'))
                ->get();
        }

        return $student;
    }
}
