<?php

namespace App\Http\Middleware;

use Closure;
use App;
use Auth;

class Language
{
    /**
     * Handle an incoming request.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \Closure  $next
     * @return mixed
     */
    public function handle($request, Closure $next)
    {
        if(!empty(session('language'))){
            App::setLocale(session('language'));
        }

        if(!Auth::check()){
            \Barryvdh\Debugbar\Facade::disable();
        }

        if(Auth::check() && !Auth::user()->hasAnyRole(['Lecturer', 'SuperAdmin', 'Developer'])){
            \Barryvdh\Debugbar\Facade::disable();
            if($user = Auth::user()->load('faculties')){
                if(!empty($user->faculties) && $user->faculties->isNotEmpty()){
                    $faculty =  $user->faculties->first();
                } else {
                    return $next($request);
                }
            }
            $request->session()->put('faculty', $faculty->id);
        }
        return $next($request);
    }
}
