<?php

namespace App\Http\Requests;

use Backpack\Base\app\Http\Requests\AccountInfoRequest as BaseRequest;
use Illuminate\Validation\Rule;

class AccountInfoRequest extends BaseRequest
{
    public function authorize()
    {
        return backpack_auth()->check();
    }

    protected function validationData()
    {
        return $this->only(backpack_authentication_column(), 'phone_number');
    }

    public function rules()
    {
        $user = backpack_auth()->user();

        return [
            backpack_authentication_column() => [
                'required',
                backpack_authentication_column() == 'email' ? 'email' : '',
                Rule::unique($user->getTable())->ignore($user->getKey(), $user->getKeyName()),
            ],
            'phone_number' => 'required',
            'avatar' => 'image|mimes:jpeg,png,jpg,gif,svg|max:2048',
        ];
    }
}
