<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Facades\Auth;

class Message extends Model
{
    public function sender()
    {
        return $this->belongsTo('App\Models\BackpackUser', 'sender_id', 'id');
    }
    public function recipient()
    {
        return $this->belongsTo('App\Models\BackpackUser', 'recipient_id', 'id');
    }
    public function getAuthorAttribute()
    {
        if ($this->recipient_id === Auth::user()->id){
            return $this->recipient->full_name;
        } else {
            return $this->recipient->full_name;
        }
    }
    public static function unreadMessages()
    {
        return Message::where('recipient_id', Auth::user()->id)
            ->where('status', false)
            ->with('sender')->orderBy('created_at', 'DESC')->paginate(10);
    }
}
