<?php

namespace App\Models;

use App\Traits\HasTranslations;
use Illuminate\Database\Eloquent\Model;
use Backpack\CRUD\CrudTrait;
use Illuminate\Support\Arr;

class ArchiveStatement extends Statement
{

    /*
    |--------------------------------------------------------------------------
    | FUNCTIONS
    |--------------------------------------------------------------------------
    */

    public function print($crud = false)
    {

        $test = 'archive_statement/';
        ob_start(); ?>
        <div class="btn-group">
            <button type="button" class="btn btn-default btn-xs dropdown-toggle" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                <i class="fa fa-print"></i> <?= __('base.statement.print') ?> <span class="caret"></span>
            </button>
            <ul class="dropdown-menu">
                <li><a href="<?= backpack_url($test . $this->id . '/print/ru') ?>"><?= __('base.ru') ?></a></li>
                <li><a href="<?= backpack_url($test . $this->id . '/print/ka') ?>"><?= __('base.ka') ?></a></li>
                <li><a href="<?= backpack_url($test . $this->id . '/print/en') ?>"><?= __('base.en') ?></a></li>
            </ul>
        </div>
        <?php
        return ob_get_clean();
    }

    public function cloneStatement($crud = false)
    {
        $test = 'archive_statement/';
        ob_start(); ?>
            <a href="<?= backpack_url($test . $this->id . '/clone') ?>" class="btn btn-xs btn-default" ><i class="fa fa-clone"></i> <?= __('base.statement.clone') ?></a>
        <?php
        return ob_get_clean();
    }

    public function edit($crud = false)
    {
        $test = 'archive_statement/';
        ob_start(); ?>
            <a href="<?= backpack_url($test . $this->id . '/rating') ?>" class="btn btn-xs btn-default" ><i class="fa fa-check"></i> <?= __('base.statement.marks') ?></a>
        <?php
        return ob_get_clean();
    }
}
