<?php

namespace App\Models;

use Backpack\CRUD\CrudTrait;
use App\Traits\HasTranslations;
use Backpack\PermissionManager\app\Models\Permission as OriginalPermission;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\MorphToMany;

class Log extends Model
{
    use CrudTrait;

    protected $table = 'log';

    protected $fillable = ['type', 'statement_id', 'user_role', 'user_full_name', 'created_at', 'updated_at'];

    public const AVAILABLE_TYPE = [
        'auth' => 'Авторизация',
        'create' => 'Создание ведомости',
        'edit' =>'Редактирование ведомости'
    ];

    public $timestamps = true;




    public function getTypesAttribute(){
        foreach (self::AVAILABLE_TYPE as $key => $value){
            if($value == $this->type) {
                return __('base.logs_users.' . $key);
            }
        }
        return 'undefined';
    }
}
